# Generic Procedures Script by Marky.
# Stores my commonly used procedures...

# ========================================================================================================
# This is part of MOOSCRIPT 3 DO NOT try and load it
# ========================================================================================================


# Globals...

set gps_floodrequest 3:10

set gps_floodrequest [split $gps_floodrequest :]

set gps_scriptver "v3.2"
set gps_scriptlogo "\002\0039\003\002gps\002\0039\003\002"
set gps_scriptdebuglogo "\002\0033\003\002gps\002\0033\003\002"
set gps_scriptname "General Procedures Script"
set gps_scriptdata " marky 1999-2000"

set gps_debug 1

# Procedures...

# ----------------------------------------------------->
# Alert Admins
# ----------------------------------------------------->

proc gps_alertadmins {opt text} {
   global moo_alertadmins botnick
   # alertadmins = 1...all +n's, otherwise each person in the list
   gps_putlog "<<INFO>> $text"
   set curtime "\037[strftime "(%d/%m/%y %H:%M)"]\037"
   if {$moo_alertadmins==1} {
      case $opt {
         1 {}
         2 {
            foreach admin [userlist n] {
               sendnote $botnick $admin "$curtime: $text"
            }
         }
         3 {
            foreach chan [channels] {
               foreach admin [chanlist $chan n] {
                  if {[info exists onlineadmins]} {
                     if {[lsearch $onlineadmins $admin]==-1} {
                        lappend onlineadmins $admin
                     } 
                  } else {lappend onlineadmins $admin}
               }
            }
            # wont work need to get their nicks
            foreach admin $onlineadmins {
               putquick "NOTICE $admin :$curtime: $text"
            } 
         }
      }
   } else {
      case $opt {
         1 {}
         2 {
            foreach admin $moo_alertadmins {
               sendnote $botnick $admin "$curtime: $text"
            }
         }
         3 {
            foreach chan [channels] {
               foreach admin $moo_alertadmins {
                  if {[handonchan $admin $chan]} {
                     if {![info exists adminlist($admin)]} {
                        set adminlist($admin) [hand2nick $admin $chan]
                     }
                  }
               }
            }

            foreach admin [array names adminlist] {
               #gps_putlog "$adminlist($admin)"
               putquick "NOTICE $adminlist($admin) :$curtime: $text"
            }

         }
      }
   }
   unset curtime

}
# ----------------------------------------------------->
# Add request
# ----------------------------------------------------->

proc gps_addrequest {reqid} {

   global gps_requests gps_floodrequest

   set maxreq [lindex $gps_floodrequest 0]
   set flushtime [lindex $gps_floodrequest 1]

   if {![info exists gps_requests($reqid)]} {
      set gps_requests($reqid) 1
      utimer $flushtime "gps_delrequest $reqid"
      return 1
   } else {
      # Check we're not flooded with requests
      if {$gps_requests($reqid)<$maxreq} {
         incr gps_requests($reqid)
         utimer $flushtime "gps_delrequest $reqid"
         return 1
      } else {
      # >3 Requests within alotted time scale
         putlog "Warning: too many requests for $reqid"
         return 0
      }
   }

}

# ----------------------------------------------------->
# Delete request
# ----------------------------------------------------->

proc gps_delrequest {reqid} {

   global gps_requests

   if {![info exists gps_requests($reqid)]} {
      return 0
   }
   if {$gps_requests($reqid)==0} {
      putlog "Warning: attempt to remove non-existant request"
   } else {
      set gps_requests($reqid) [expr $gps_requests($reqid) - 1]
   }
    
}

# ----------------------------------------------------->
# List Admins
# ----------------------------------------------------->

proc gps_listadmins {nick uhost hand args} {

   global botnick

   if {![gps_addrequest "LISTADMINS"]} {return 0}
   putlog "<<LISTADMINS>> Requested by $nick!$uhost"
   gps_putmsg $nick "\037Listing active admins on $botnick:\037"

   foreach chan [channels] {
      foreach admin [chanlist $chan n] {
         lappend adminlist($admin) $chan
         if {[info exists onlineadmins]} {
            if {[lsearch $onlineadmins $admin]==-1} {
               lappend onlineadmins $admin
            } 
         } else {lappend onlineadmins $admin}

      }
   }

   foreach admin $onlineadmins {
      gps_putmsg $nick "Name: \002$admin\002 Currently on: $adminlist($admin)"
   }


}

# ----------------------------------------------------->
# List Auths
# ----------------------------------------------------->

proc gps_listauths {nick uhost hand args} {

   global botnick

   if {![gps_addrequest "LISTAUTHS"]} {return 0}
   putlog "<<LISTAUTHS>> Requested by $nick!$uhost"
   gps_putmsg $nick "\037Listing AUTH'd users on $botnick:\037"

   if {![file exists "./auths.ini"] || [file size "./auths.ini"] == 0} {
      gps_newauthfile
      putlog "Error: auths file is corrupt"
      return
   }

   set gps_authfile [open "./auths.ini" r]
   set gps_aflinenum 0
   while {![eof $gps_authfile]} {
      gets $gps_authfile gps_authlist($gps_aflinenum)
      incr gps_aflinenum
   }
   close $gps_authfile
   set gps_afdatalines [expr $gps_aflinenum - 2]
   set gps_authedusers [expr $gps_aflinenum - 3]

   if {$gps_authlist(0)!="!AUTH DATABASE START! marky"} {
      gps_newauthfile
      putlog "Error: auths file is corrupt"
      return
   }

   if {$gps_authlist($gps_afdatalines)!="!AUTH DATABASE END! marky"} {
      gps_newauthfile
      putlog "Error: auths file is corrupt"
      return
   }   
   if {$gps_authedusers==0} {gps_putmsg $nick "No authed users."; return}
   gps_putmsg $nick "Currently: $gps_authedusers users AUTH'd..."

   # Ok, here's the real checking...auth file is there, it looks ok and there's some auths in it.

   set gps_isauthed 0
   set gps_checkedauths 0

   while {$gps_checkedauths<$gps_authedusers} {
      set ahand [lindex $gps_authlist([expr $gps_checkedauths + 1]) 0]
      set ahost [lindex $gps_authlist([expr $gps_checkedauths + 1]) 1]
      gps_putmsg $nick "Handle: \002$ahand\002 Hostmask: \002$ahost\002"
      incr gps_checkedauths
   }

}

# ----------------------------------------------------->
# WHOAMI
# ----------------------------------------------------->

proc gps_whoami {nick uhost hand args} {

   set whoami_output "Who are you?"

   if {$hand=="*"} { 
      set whoami_output "$whoami_output Fuck knows tbh, I haven't got a clue.  Have you authed?  Have you even been added to my users database?"
   } else {
      set whoami_output "$whoami_output Your user handle is \002$hand\002, You're "
      if {[matchattr $hand n]} { set whoami_output "$whoami_output a global owner, "
      } elseif {[matchattr $hand m]} { set whoami_output "$whoami_output a global master,"
      } elseif {[matchattr $hand o]} { set whoami_output "$whoami_output a global op,"
      } elseif {[matchattr $hand v]} { set whoami_output "$whoami_output a global voice," }
      if {[matchattr $hand f]} { set whoami_output "$whoami_output a global friend," }
      
      foreach chan [channels] {
         if {[matchattr $hand |n $chan]} { set whoami_output "$whoami_output an owner on $chan,"
         } elseif {[matchattr $hand |m $chan]} { set whoami_output "$whoami_output a master on $chan,"
         } elseif {[matchattr $hand |o $chan]} { set whoami_output "$whoami_output an op on $chan,"
         } elseif {[matchattr $hand |v $chan]} { set whoami_output "$whoami_output a voice on $chan,"
         } elseif {[matchattr $hand |f $chan]} { set whoami_output "$whoami_output a friend on $chan,"
         }
      }      
      
   }
   
   gps_putnotice $nick "$whoami_output :D"

}

# ----------------------------------------------------->
# Quit Handler
# ----------------------------------------------------->

proc gps_quithandler {nick uhost hand chan reason} {

   global gps_lastquit

   # Quit handler, if a person is on multiple chans with the bot on when they 
   # quit, it would cause their auth to be removed many times very quickly
   # which means quite a bit of disk access... This prevents it.

   # I've stopped this because it pisses me off
   return 0

   if {$hand=="*"} {return}
   if {![info exists gps_lastquit]} {
      set gps_lastquit $hand
      gps_remauth $hand
      utimer 5 {
         unset gps_lastquit
      }
   } else {
      if {$gps_lastquit!=$hand} {
         gps_remauth $hand
         utimer 5 {
            if {[info exists gps_lastquit]} {
               unset gps_lastquit
            }
         }
      }
   }


}

# ----------------------------------------------------->
# Auth Handler
# ----------------------------------------------------->

proc gps_authhandler {nick uhost hand args} {

   global botnick

   set args [join $args]
   set gps_authhand [string range $args 0 [string first " " $args]]
   set gps_authpass [string range $args [expr [string first " " $args] + 1] end]
   if {![validuser $gps_authhand]} {
      puthelp "NOTICE $nick :AUTH failure. Unknown user handle ($gps_authhand)."
      gps_putlog "<<AUTH>> (\002FAILED\002) $nick as $gps_authhand (*!$uhost) \[unknown user handle\]"
      return
   }
   if {[passwdok $gps_authhand ""]} {
      setuser $gps_authhand HOSTS [string tolower "*$nick*![string range $uhost [string first "!" $uhost] [string first "@" $uhost]]*"]
      puthelp "NOTICE $nick :Added your current host to $gps_authhand in userfile."
      puthelp "NOTICE $nick :AUTH failure. Please set a password: /msg $botnick PASS <password>."
      gps_putlog "<<AUTH>> (\002FAILED\002) $nick as $gps_authhand (*!$uhost) \[no password set\]"
      return
   }
   if {[passwdok $gps_authhand $gps_authpass]} {

      # OK, password is correct for the handle...Check if the user currently has that handle.
      # Get correct case of handle?
      set host [lindex [getuser $gps_authhand hosts] 0]
      set gps_authhand [finduser $host]

      if {$hand=="*"} {
         # Currently no handle, so add their hostmask to the userfile.
         
         
         # setuser $gps_authhand HOSTS [string tolower "*$nick*![string range $uhost [string first "!" $uhost] [string first "@" $uhost]]*"]
         # ^^^^^^^ my old method.. bit crappy but what the hell.
         setuser $gps_authhand HOSTS [maskhost $nick![string range $uhost [string first "!" $uhost] end]]
         puthelp "NOTICE $nick :Added your current host to $gps_authhand in userfile."
         gps_putlog "<<AUTH>> $nick as $gps_authhand (*!$uhost) \[no hostmasks, added current\]"
      } elseif {[string tolower $hand]!=[string tolower $gps_authhand]} {
         # They are authed under another handle...this shouldn't happen
         puthelp "NOTICE $nick :AUTH failure.  Your handle seems to be $hand but you're trying to auth as $gps_authhand.  Please consult an administrator: /msg $botnick LISTADMINS"
         gps_putlog "<<AUTH>> (\002FAILED\002) $nick as $gps_authhand (*!$uhost) \[authed under another handle\]"
         return
      }

      switch [gps_isauthed $gps_authhand $uhost] {
         0 {
               # Auth file exists, hand not authed.
               gps_addauth $gps_authhand $uhost
               puthelp "NOTICE $nick :AUTH'd sucessfully as *!$uhost."
               gps_putlog "<<AUTH>> $nick as $gps_authhand (*!$uhost) \[user wasn't authed\]"
           }

         1 {
               # Auth file exists, hand is already authed under current host.
               puthelp "NOTICE $nick :Already authed as *!$uhost."
               gps_putlog "<<AUTH>> $nick as $gps_authhand (*!$uhost) \[already authed\]"
           }

         2 {
               # Auth file exists, user was authed under different host.
               gps_modauth $gps_authhand $uhost
               puthelp "NOTICE $nick :AUTH'd sucessfully as *!$uhost, hostmask changed."
               gps_putlog "<<AUTH>> $nick as $gps_authhand (*!$uhost) \[user wasn't authed\]"
           }

         5 {
               # Auth file corrupt, no auths.
               gps_addauth $gps_authhand $uhost
               puthelp "NOTICE $nick :AUTH'd sucessfully as *!$uhost. Database rebuilt."
               gps_putlog "<<AUTH>> $nick as $gps_authhand (*!$uhost) \[auth file corrupt\]"
           }
      }

      return

   } else {
      puthelp "NOTICE $nick :AUTH failure. Incorrect password for $gps_authhand."
      gps_putlog "<<AUTH>> (\002FAILED\002) $nick as $gps_authhand (*!$uhost) \[incorrect password\]"
      return
   }
}

# ----------------------------------------------------->
# Auth Checker
# ----------------------------------------------------->

proc gps_isauthed {hand uhost} {

   # Returns:
   # 0 User is not authed.
   # 1 User is authed.
   # 2 Hostmask changed since last auth.
   # 5 Corrupt/missing auths.ini file.

   if {![file exists "./auths.ini"] || [file size "./auths.ini"] == 0} {
      gps_newauthfile
      return 5
   }

   set gps_authfile [open "./auths.ini" r]
   set gps_aflinenum 0
   while {![eof $gps_authfile]} {
      gets $gps_authfile gps_authlist($gps_aflinenum)
      incr gps_aflinenum
   }
   close $gps_authfile
   set gps_afdatalines [expr $gps_aflinenum - 2]
   set gps_authedusers [expr $gps_aflinenum - 3]

   if {$gps_authlist(0)!="!AUTH DATABASE START! marky"} {
      gps_newauthfile
      return 5
   }
   if {$gps_authlist($gps_afdatalines)!="!AUTH DATABASE END! marky"} {
      gps_newauthfile
      return 5
   }   
   if {$gps_authedusers==0} {return 0}

   # Ok, here's the real checking...auth file is there, it looks ok and there's some auths in it.

   set gps_isauthed 0
   set gps_checkedauths 0

   while {$gps_checkedauths<=$gps_authedusers} {
      if {[lindex $gps_authlist([expr $gps_checkedauths + 1]) 0]==$hand} {
         # found handle of user, check hostmasks....
         if {[lindex $gps_authlist([expr $gps_checkedauths + 1]) 1] == [string range $uhost [string first "!" $uhost] end]} {
            set gps_isauthed 1
         } else {
            set gps_isauthed 2
         }
      }
      incr gps_checkedauths
   }

   return $gps_isauthed
      

}

# ----------------------------------------------------->
# Create New Auth File
# ----------------------------------------------------->

proc gps_newauthfile {} {

   set gps_authfile [open "./auths.ini" w]
   puts $gps_authfile "!AUTH DATABASE START! marky"
   puts $gps_authfile "!AUTH DATABASE END! marky"
   close $gps_authfile

}

# ----------------------------------------------------->
# Modify Auth 
# ----------------------------------------------------->

proc gps_modauth {hand uhost} {

   set gps_authfile [open "./auths.ini" r]
   set gps_aflinenum 0
   while {![eof $gps_authfile]} {
      gets $gps_authfile gps_authlist($gps_aflinenum)
      incr gps_aflinenum
   }
   close $gps_authfile
   set gps_afdatalines [expr $gps_aflinenum - 3]
   set gps_authedusers [expr $gps_aflinenum - 3]

   # Copy current auth list into new list and modify the auth

   set gps_newauths 0

   for {set reps 1} {$reps <= $gps_authedusers} {incr reps} {
      if {[lindex $gps_authlist($reps) 0] != $hand} {
         set gps_newauthlist($gps_newauths) $gps_authlist($reps)
         incr gps_newauths
      } else {
         set gps_newauthlist($gps_newauths) "$hand $uhost"
         incr gps_newauths
      }
   }

   set gps_authfile [open "./auths.ini" w]
   puts $gps_authfile "!AUTH DATABASE START! marky"
   set gps_copiedauths 0
   set gps_aflinenum 0
   while {!$gps_copiedauths} {
       puts $gps_authfile $gps_newauthlist($gps_aflinenum)
       incr gps_aflinenum
       if {$gps_aflinenum >= $gps_newauths} {set gps_copiedauths 1}
   }
   puts $gps_authfile "!AUTH DATABASE END! marky"
   close $gps_authfile

}

# ----------------------------------------------------->
# Add Auth
# ----------------------------------------------------->

proc gps_addauth {hand uhost} {

   set gps_authfile [open "./auths.ini" r]
   set gps_aflinenum 0
   while {![eof $gps_authfile]} {
      gets $gps_authfile gps_authlist($gps_aflinenum)
      incr gps_aflinenum
   }
   close $gps_authfile
   set gps_afdatalines [expr $gps_aflinenum - 3]
   set gps_authedusers [expr $gps_aflinenum - 3]

   # Copy current auth list into new list and add the auth

   if {$gps_authedusers<=0} {
      # If here, file corrupt or no authed users...so just add the single auth to the new list
      set gps_newauthlist(0) "$hand [string range $uhost [expr [string first "!" $uhost] +1] end]"
      set gps_newauths 0
      # Don't worry about above 0, we'll add 1 later on. (or use > instead of == ;)
   } else {
      # Copy auth lines from original list to new list and add new auth
      set gps_copiedauths 0
      set gps_newauths 0
      while {!$gps_copiedauths} {
         set gps_newauthlist($gps_newauths) $gps_authlist([expr $gps_newauths + 1])
         # Above line has +1 so it starts 1 line from beginning of file, i.e. where the
         # data actually starts
         incr gps_newauths
         if {$gps_newauths == $gps_authedusers} {
            set gps_newauthlist($gps_newauths) "$hand [string range $uhost [expr [string first "!" $uhost] +1] end]"
            set gps_copiedauths 1
         }
      }
   }

   # Now new list is compiled, write it...

   set gps_authfile [open "./auths.ini" w]
   puts $gps_authfile "!AUTH DATABASE START! marky"
   set gps_copiedauths 0
   set gps_aflinenum 0
   while {!$gps_copiedauths} {
       puts $gps_authfile $gps_newauthlist($gps_aflinenum)
       incr gps_aflinenum
       if {$gps_aflinenum > $gps_newauths} {set gps_copiedauths 1}
   }
   puts $gps_authfile "!AUTH DATABASE END! marky"
   close $gps_authfile

}

# ----------------------------------------------------->
# Remove Auth
# ----------------------------------------------------->

proc gps_remauth {hand} {

   set gps_authfile [open "./auths.ini" r]
   set gps_aflinenum 0
   while {![eof $gps_authfile]} {
      gets $gps_authfile gps_authlist($gps_aflinenum)
      incr gps_aflinenum
   }
   close $gps_authfile
   set gps_afdatalines [expr $gps_aflinenum - 3]
   set gps_authedusers [expr $gps_aflinenum - 3]

   # Copy all but the removed auth into new list then write.

   set gps_newauths 0

   for {set reps 1} {$reps <= $gps_authedusers} {incr reps} {
      if {[lindex $gps_authlist($reps) 0] != $hand} {
         set gps_newauthlist($gps_newauths) $gps_authlist($reps)
         incr gps_newauths
      }
   }


   set gps_authfile [open "./auths.ini" w]
   puts $gps_authfile "!AUTH DATABASE START! marky"
   set gps_copiedauths 0
   set gps_aflinenum 0
   if {$gps_newauths>0} {
      while {!$gps_copiedauths} {
          puts $gps_authfile $gps_newauthlist($gps_aflinenum)
          incr gps_aflinenum
          if {$gps_aflinenum == $gps_newauths} {set gps_copiedauths 1}
      }
   }
   puts $gps_authfile "!AUTH DATABASE END! marky"
   close $gps_authfile

}

# ----------------------------------------------------->
# Output Message
# ----------------------------------------------------->

proc gps_putmsg {nick text} {

   puthelp "PRIVMSG $nick :$text"

}

# ----------------------------------------------------->
# Output Notice
# ----------------------------------------------------->

proc gps_putnotice {nick text} {

   puthelp "NOTICE $nick :$text"

}

# ----------------------------------------------------->
# String Cleaner
# ----------------------------------------------------->

proc gps_trimtext {text} {

   # Clean the string
   if {[info exists cleantext]} {set cleantext ""}
   for {set x 0} {$x<=[string length $text]} {incr x} {
      set tmpchar [string index $text $x]
      if {[gps_cleanchar $tmpchar]} {
         append cleantext $tmpchar
      }
   }  
   return [string tolower $cleantext]
}

# ----------------------------------------------------->
# Character Cleaner
# ----------------------------------------------------->

proc gps_cleanchar {char} {

   global gps_prevcolcode

   if {![info exists gps_prevcolcode]} {set gps_prevcolcode 0}

   set tmp_validchar 1

   if {$gps_prevcolcode} {
      if {($char=="0")||($char=="1")||($char=="2")||($char=="3")||($char=="4")|| \
          ($char=="5")||($char=="6")||($char=="7")||($char=="8")||($char=="9")||($char==",")} {
         set tmp_validchar 0} else {
         set gps_prevcolcode 0 }
   }

   if {$char=="\001"} {set tmp_validchar 0}
   if {$char=="\002"} {set tmp_validchar 0}
   if {$char=="\003"} {
      set tmp_validchar 0
      set gps_prevcolcode 1}
   if {$char=="\026"} {set tmp_validchar 0}
   if {$char=="\037"} {set tmp_validchar 0}
   if {$char=="\040"} {set tmp_validchar 0}
   if {$char=="\042"} {set tmp_validchar 0}
   if {$char=="\047"} {set tmp_validchar 0}
   if {$char=="\054"} {set tmp_validchar 0}
   if {$char=="\056"} {set tmp_validchar 0}
   if {$char=="\072"} {set tmp_validchar 0}
   if {$char=="\077"} {set tmp_validchar 0}

   if {!$tmp_validchar} {
      unset tmp_validchar
      return 0
   } else {
      unset tmp_validchar
      return 1
   }

}

# ----------------------------------------------------->
# Debug Handler
# ----------------------------------------------------->

proc gps_putdebug {text} {

   global gps_debug gps_scriptdebuglogo

   if {$gps_debug} {
      putlog "$gps_scriptdebuglogo: $text"
   }

}

# ----------------------------------------------------->
# Log Handler
# ----------------------------------------------------->

proc gps_putlog {text} {

   global gps_scriptlogo

   putlog "$gps_scriptlogo: $text"

}

# ----------------------------------------------------->
# List item remover
# ----------------------------------------------------->

proc gps_delentity {num} {

   # Maybe it's just me, or maybe TCL lists are actually shit
   # If anybody knows an easy way to remove an entity from a TCL list
   # please let me know.. lreplace "" is a bit shit as it leaves a blank
   # list element in its place , i.e. {}

}

# End of procedures.

# Initialisation stuff.

putcmdlog "$gps_scriptname $gps_scriptver $gps_scriptdata initialised."
gps_putlog "script loaded"

# End of script
# End of script
# End of script
# End of script
# End of script
# End of script
# End of script
# End of script
# End of script
# End of script
# End of script
# The End.
